
package aspect02;
import java.util.Observable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * This listener forwards selections made in the aspect list to
 * the application model.
 * @author B. Gaertner
 */
public class AspectSelectionListener
          extends Observable
          implements ListSelectionListener {

    @Override
    public void valueChanged(ListSelectionEvent e) {
        if (!e.getValueIsAdjusting())
        {
            this.setChanged();
            this.notifyObservers(e);
        }
    }
}
