
package aspect02;
import common.RemoveableJList;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import mvc.ComponentContainer;
import mvc.SimpleModel;

/**
 *
 * @author Projekte
 */
public class Model2Presenter extends JComponent
          implements LayoutManager {

    SimpleModel2 model;
    public Model2Presenter (SimpleModel2 m) {
        model = m;
    }

    public void installInto(ComponentContainer<SimpleModel> cc) {
        cc.setLayout(this);
        AspectSelectionListener al1 = new AspectSelectionListener();
        AspectSelectionListener al2 = new AspectSelectionListener();

        JScrollPane scrollPane1 = new JScrollPane();
        RemoveableJList<LineEndAspect> listfield = new RemoveableJList<>(model.getListModel1());
        listfield.setSelectionModel(model.getListSelection1());
        scrollPane1.setViewportView(listfield);
        listfield.addListSelectionListener(al1);

        JScrollPane scrollPane2 = new JScrollPane();
        RemoveableJList<LineJoinAspect> listfield2 = new RemoveableJList<>(model.getListModel2());
        listfield2.setSelectionModel(model.getListSelection2());
        scrollPane2.setViewportView(listfield2);
        listfield2.addListSelectionListener(al2);

        int idx1 = model.getListSelection1().getMaxSelectionIndex();
        int idx2 = model.getListSelection2().getMaxSelectionIndex();
        if (idx1 == -1) {
            idx1 = 0;
        }
        if (idx2 == -1) {
            idx2 = 0;
        }
        DrawingPanel2 paintArea = new DrawingPanel2(al1, al2,
                ((LineEndAspect)model.getListModel1().getElementAt(idx1)).getValue(),
                ((LineJoinAspect)model.getListModel2().getElementAt(idx2)).getValue());
        paintArea.setBackground(Color.WHITE);
        cc.add(scrollPane1);
        cc.add(scrollPane2);
        cc.add(paintArea);
    }

    @Override
    public void addLayoutComponent(String name, Component comp) {
        //  no action needed
    }

    @Override
    public void removeLayoutComponent(Component comp) {
        // no action needed
    }

    @Override
    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 100
                    + insets.left + insets.right;
        dim.height = 100
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 60
                    + insets.left + insets.right;
        dim.height = 26
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public void layoutContainer(Container parent) {

        Insets insets = parent.getInsets();
        int maxWidth = parent.getWidth()
                       - (insets.left + insets.right) - 1;
        int maxHeight = parent.getHeight()
                        - (insets.top + insets.bottom);
        int nComps = parent.getComponentCount();
        int x = insets.left;
        int y = insets.top;

        Component c = parent.getComponent(0);  // upper list view
        c.setBounds(x, y, maxWidth / 3, maxHeight/2);
        c = parent.getComponent(1);            // lower list view
        c.setBounds(x, y + maxHeight/2, maxWidth / 3, maxHeight - maxHeight/2);
        c = parent.getComponent(2);            // paint area
        c.setBounds(x + maxWidth/3, y, maxWidth - maxWidth/3, maxHeight);
    }
}
