
package aspect03;
import common.SliderListener;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.util.Observable;
import java.util.Observer;
import javax.swing.JComponent;
/**
 *
 * @author Projekte
 */
public class ColorDisplayField extends JComponent
         implements Observer {

    private SliderListener red;
    private SliderListener green;
    private SliderListener blue;

    public ColorDisplayField (SliderListener r, SliderListener g, SliderListener b) {
        red = r;
        green = g;
        blue = b;
        this. registerAsObserver();
    }

    private void registerAsObserver() {
        red.addObserver(this);
        green.addObserver(this);
        blue.addObserver(this);
    }

    /**
     * Methode für das Zeichnen in das Anzeigeelement. Für den eigentlichen
     * Zeichenvorgang wird die Methode <b>InhaltZeichnen</b> aufgerufen.
     * @param g Instanz von Graphics; das zu verwendende Zeicheninstrument
     */
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Dimension groesse = this.getSize();
        Rectangle bereich = new Rectangle(groesse);
        this.InhaltZeichnen((Graphics2D)g, bereich);
    }

    /**
     * Diese Methode erledigt den eigentlichen Zeichenvorgang
     * @param g Graphics2D, das gebrauchsfertig cvorbereitete Zeicheninstrument
     * @param bereich Rechtangle, der Bereich in den das Zeicheninstrument
     * zeichnen kann.
     */
    private void InhaltZeichnen(Graphics2D g, Rectangle bereich){
        bereich.grow(-5, -5);
        g.setColor(new Color(red.getCurrentValue(),
                green.getCurrentValue(),
                blue.getCurrentValue()));

        g.fillRect(bereich.x, bereich.y, bereich.width, bereich.height);
    }

    @Override
    public void update(Observable o, Object arg) {
        this.repaint();
    }
}
