
package aspect03;
import common.RemoveableJSlider;
import common.SliderListener;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import javax.swing.JSlider;
import mvc.ComponentContainer;
import mvc.SimpleModel;
/**
 *
 * @author Projekte
 */
public class Model3Presenter implements LayoutManager {

    SimpleModel3 model;

    public Model3Presenter (SimpleModel3 m) {
        model = m;
    }
    public void installInto(ComponentContainer<SimpleModel> cc) {
        cc.setLayout(this);
        RemoveableJSlider slider1 = new RemoveableJSlider(model.getSliderModelRed());
        slider1.setBackground(new Color(255, 200, 200));
        slider1.setOrientation(JSlider.VERTICAL);
        SliderListener sl1 = new SliderListener(model.getSliderModelRed());
        slider1.addChangeListener(sl1);

        RemoveableJSlider slider2 = new RemoveableJSlider(model.getSliderModelGreen());
        slider2.setBackground(new Color(200, 255, 200));
        slider2.setOrientation(JSlider.VERTICAL);
        SliderListener sl2 = new SliderListener(model.getSliderModelGreen());
        slider2.addChangeListener(sl2);

        RemoveableJSlider slider3 = new RemoveableJSlider(model.getSliderModelBlue());
        slider3.setBackground(new Color(200, 200, 255));
        slider3.setOrientation(JSlider.VERTICAL);
        SliderListener sl3 = new SliderListener(model.getSliderModelBlue());
        slider3.addChangeListener(sl3);

        ColorDisplayField paintArea = new ColorDisplayField(sl1, sl2, sl3);
        paintArea.setBackground(Color.WHITE);

        cc.add(slider1);
        cc.add(slider2);
        cc.add(slider3);
        cc.add(paintArea);
    }

    @Override
    public void addLayoutComponent(String name, Component comp) {
        // no action needed
    }

    @Override
    public void removeLayoutComponent(Component comp) {
        // no action needed
    }

    @Override
    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 100
                    + insets.left + insets.right;
        dim.height = 100
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 60
                    + insets.left + insets.right;
        dim.height = 26
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public void layoutContainer(Container parent) {

        Insets insets = parent.getInsets();
        final int maxWidth = parent.getWidth()
                       - (insets.left + insets.right) - 1;
        final int maxHeight = parent.getHeight()
                        - (insets.top + insets.bottom);
        final int nComps = parent.getComponentCount();
        final int sliderWidth = 50;
        final int y = insets.top;
        if (nComps == 0) {
            return;
        }

        // now, compute x origin and width for all four components
        for (int i = 0; i < 3; i++) {
            Component c = parent.getComponent(i);
            c.setBounds(i*sliderWidth + insets.left, y, sliderWidth, maxHeight);
        }

        Component c = parent.getComponent(3);
        c.setBounds(insets.left + 3*sliderWidth, y,
                maxWidth - 3*sliderWidth, maxHeight);
    }
}
