
package aspect04;


import common.RemoveableCheckBox;
import common.RemoveableJComboBox;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import mvc.ComponentContainer;
import mvc.SimpleModel;

/**
 *
 * @author Projekte
 */
public class Model4Presenter extends JComponent
          implements LayoutManager {

    SimpleModel4 model;
    public Model4Presenter (SimpleModel4 m) {
        model = m;
    }

    public void installInto(ComponentContainer<SimpleModel> cc) {
        cc.setLayout(this);


        JScrollPane scrollPane1 = new JScrollPane();
        RemoveableJComboBox<Integer> listfield = new RemoveableJComboBox<>(model.getValueListModel1());
        DefaultListCellRenderer renderer = new DefaultListCellRenderer();
        renderer.setHorizontalAlignment(DefaultListCellRenderer.RIGHT);
        listfield.setRenderer(renderer);
        scrollPane1.setViewportView(listfield);

        JScrollPane scrollPane2 = new JScrollPane();
        RemoveableJComboBox<Integer> listfield2 = new RemoveableJComboBox<>(model.getValueListModel2());
        renderer = new DefaultListCellRenderer();
        renderer.setHorizontalAlignment(DefaultListCellRenderer.RIGHT);
        listfield2.setRenderer(renderer);
        scrollPane2.setViewportView(listfield2);

        RemoveableCheckBox checkBox = new RemoveableCheckBox("Kantenglättung");
        checkBox.setModel(model.getButtonModel());

        DiagramPainter paintArea = new DiagramPainter(listfield, listfield2, checkBox);
        paintArea.setBackground(Color.WHITE);
        listfield.addActionListener(paintArea);
        listfield2.addActionListener(paintArea);
        checkBox.addActionListener(paintArea);
        cc.add(scrollPane1);
        cc.add(scrollPane2);
        cc.add(paintArea);
        cc.add(checkBox);
    }

    @Override
    public void addLayoutComponent(String name, Component comp) {
        //  no action needed
    }

    @Override
    public void removeLayoutComponent(Component comp) {
        // no action needed
    }

    @Override
    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 100
                    + insets.left + insets.right;
        dim.height = 100
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 60
                    + insets.left + insets.right;
        dim.height = 26
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public void layoutContainer(Container parent) {

        Insets insets = parent.getInsets();
        int maxWidth = parent.getWidth()
                       - (insets.left + insets.right);
        int maxHeight = parent.getHeight()
                        - (insets.top + insets.bottom);
        int nComps = parent.getComponentCount();
        int x = insets.left;
        int y = insets.top;
        final int boxHeight = 28;
        final int buttonHeight = 28;

        Component c = parent.getComponent(0);  // upper list view
        c.setBounds(x, y, maxWidth / 2, boxHeight);
        c = parent.getComponent(1);            // lower list view
        c.setBounds(x + maxWidth / 2, y, maxWidth - maxWidth / 2, boxHeight);
        c = parent.getComponent(2);            // paint area
        c.setBounds(x , y + boxHeight, maxWidth, maxHeight - boxHeight - buttonHeight);
        c = parent.getComponent(3);            // paint area
        c.setBounds(x , y + maxHeight - buttonHeight, maxWidth, buttonHeight);
    }
}
