
package common;

import java.util.Observable;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.DefaultBoundedRangeModel;

/**
 *
 * @author Projekte
 */
public class SliderListener extends Observable implements ChangeListener{
    /**
     * der aktuelle Wert des Schiebereglers
     */
    private int currentValue;

    public SliderListener(DefaultBoundedRangeModel m) {
        super();
        currentValue = m.getValue();
    }
    /**
     * Mit dieser Methode meldet der JSlider eine Änderung seines
     * eingestellten Wertes. Überdies wird die Benachrichtigung der
     * Observer veranlasst.
     * @param e eine Instanz von ChangeEvent
     */
    @Override
    public void stateChanged(ChangeEvent e)
    {
        JSlider source = (JSlider)e.getSource();
        currentValue = (int)source.getValue();
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Observer rufen diese Methode auf, um den aktuellen Wert des
     * beobachteten Schiebereglers zu erfragen
     * @return den aktuellen wert des Schiebereglers, ein int.
     */
    public int getCurrentValue ()
    {
        return currentValue;
    }
}
