
package mvc;

import java.util.Observable;

/**
 * Eine Instanz realisiert einen beobachtbaren Speicherplatz
 * für eine Instanz einer Modellklasse.
 * @author B. Gaertner
 */
public class ModelHolder<ModelType extends IModel<ModelType>>
         extends Observable {
    ModelType model;
    public ModelHolder (ModelType m) {
        model = m;
    }

    public void installPresenterIn(ComponentContainer<ModelType> cc) {
        if (model != null) {
            model.installNewComponent(cc);
        }
    }

    public void setModel (ModelType m) {
        model = m;
        this.setChanged();
        this.notifyObservers();
    }

    public boolean hasModel() {
        return model != null;
    }
}
