package mvc002;
import mvc.IEnumIDs;


/**
 * Aspekte werden verwendet, weil sie in switch-Statements verwendbar sind.
 * Für die Anzeige in einer Liste genügt der default renderer, der die
 * Zeichenreihe verwendet, die durch  toString() zur Verfügung gestellt wird.
 * @author development
 */
public enum Aspect implements IEnumIDs {
    VOID ("void", 0),
    ITEM_01 ("aspect_01", 1),
    ITEM_02 ("aspect_02", 2),
    ITEM_03 ("aspect_03", 3),
    ITEM_04 ("aspect_04", 4),
    ITEM_05 ("aspect_05", 5),
    ITEM_06 ("aspect_06", 6);


    /**
     * the display string of the enum value
     */
    private String name;
    private int id;

    /**
     * Create a value and assign a display string
     * @param n the display string to be used
     */
    Aspect (String n, int nId) {
        this.name = n;
        this.id = nId;
    }

    /**
     * This method return the display string for use in a JList
     * @return display string of the enum value
     * @see JList
     */
    @Override
    public String toString() {
        return name;
    }

    @Override
    public int getID() {
        return id;
    }

}